
#include 'AppEvent.ch'
#include 'Gra.ch'
#include 'Inkey.ch'
#include 'Set.ch'
#include 'Xbp.ch'
#define  CR      Chr(13)
#define  CRLF    Chr(13) + Chr(10)

STATIC  oCrt
FUNCTION Main()
LOCAL  oDlg,  oOldApp, oOldFocus

oDlg           := XbpDialog():new(,,, {900, 650}, , .f.)
oDlg:tasklist  := .t.
oDlg:border    := XBPDLG_RAISEDBORDERTHICK
oDlg:sysmenu   := .t.
oDlg:taskList  := .t.
oDlg:titleBar  := .t.
oDlg:maxButton := .f.
oDlg:title     := ('FILE CONTAINS  ANSI  STRINGS')
oDlg:create()
oDlg:drawingArea:setColorBG(GraMakeRGBColor({255, 255, 255}))
oDlg:drawingArea:setColorFG(GraMakeRGBColor({255, 255, 255}))

oCrt := XbpCrt():New(oDlg:drawingArea,, {0,0}, 25, 80, oDlg:title, .f.)
oCrt:mouseMode := XBPCRT_MOUSEMODE_VIO
oCrt:title     := 'TESTING XbpPresspace()'
oCrt:useShortCuts := .t.
oCrt:Create()
oCrt:AutoFocus   := .t.
oCrt:AutoMark    := .f.
oCrt:presSpace():setColor(GramakeRGBColor({255,0,0}), GramakeRGBColor({255,255,255}))

CenterControl(oCrt)
CenterControl(oDlg)
oDlg:show()
oCrt:show()
oOldApp   := SetAppWindow(oCrt)
oOldFocus := SetAppFocus(oCrt)

ConfirmBox(NIL, ('About to start Printing.'                          + CR + CR +;
                 'PLEASE change the "Printer++" to the printer'           + CR +;
                 'that you will to use.'                             + CR + CR +;
                 'The line "Set CharSet to OEM" only will work'           + CR +;
                 'if the method Printform_:init() starts the thread'      + CR +;
                 'executing the method ::start().'                   + CR + CR +;;
                 'if the method Printform_:init() starts the thread'      + CR +;
                 'executing the method ::execute() the line'              + CR +;
                 '"Set Charset to OEM" will to be ignored.'          + CR + CR +;
                 'These methods are in the program PrintFor.prg.'    + CR + CR +;
                 'If you debug the thread Printform_() you will see'      + CR +;
                 'that allways Set(_SET_CHARSET) is == CHARSET_ANSI'),;
                 'PRINTING TEST',;
                XBPMB_OK)
Set Console Off
PrintForm_():new('wk5CAAC7.prn',;
                 'gra',;
                 'Printer++',;
                 '',;
                 'Testing',;         // User name
                 'Courier New',;     // Font family
                 24,;                // Width
                 40,;                 // Height
                 143,;                // Total of columns
                 'Test',;            // Application code for to show in title
                 {})                 // Call Stack for to be shown in case of printing error
                  //
Set Charset to OEM
ConfirmBox(NIL, 'Finished printing',;
                'FINISHED',;
                XBPMB_OK)
Set Console On
SetAppWindow(oOldApp)
SetAppFocus(oOldFocus)
RETURN NIL

PROCEDURE AppSys()
   SET CHARSET     TO ANSI
   SET CONFIRM     OFF
   SET DATE        GERMAN
   SET CENTURY     ON
   SET DECIMALS    TO     2
   SET DELETED     ON
   SET DELIMITERS  ON
   SET DELIMITERS  TO '><'                // Chr(179) + Chr(179)
   SET EPOCH       TO 2000                // Para as converses de datas quando o ano tem menos de 4 caracteres
   SET ESCAPE      ON
   SET EXACT       ON
   SET FIXED       OFF
   SET INTENSITY   ON
   SET SCOREBOARD  OFF
   SET SOFTSEEK    OFF
   SET TYPEAHEAD   TO     100                // Limite de caracteres p/ keyboard
RETURN

 ////////////
 //
FUNCTION GraSetPointer_(oXbp, cDll, nResId, nType)
 //      Retorns lSuccess
 ///////
if oXbp == NIL
   oXbp := SetAppWindow()
endif
if cDll <> NIL                     .and.;
   Lower(Right(cDll, 4)) <> '.dll'
   cDll += '.dll'
endif
RETURN oXbp:setPointer(cDll, nResId, nType)

 ////////////
 //
FUNCTION LoadBitMap_(oPS, xBitmap,    cDll,        cUserDef, aSize, nRasterOp, nCompress, nState,;
                          lIco2Bitmap, nBGIcon)
 //
 //
 //      Retorns XbpBitMap() or XbpIcon() or NIL
 /////
LOCAL  cType, nFormat, oImage, oNewBmp, nNewWidth, nNewHeight, oBmpPS

do while .t.
                  //
                  //    Se <xBitmap> for array os parmetros so assumidos atravs de seus itens
   if Valtype(xBitmap) == 'A'             // Pr definido para loadbitmap
      aSize(xBitmap, 3)
      cDll             := xBitmap[02]
      cUserDef         := xBitmap[03]
      xBitmap          := xBitmap[01]     //  o ltimo porque <xBitmap> original  um array
   endif
   cType               := Valtype(xBitmap)

   if ValType(cDll) $ 'C'
      ApiLoadDll_(cDll)
   endif
                  //
                  //    Obteremos as imagens conforme especificao
   if cType  == 'O'                       // Objeto que talvez possa ser redimensionado
      oImage := xBitMap
      exit
   endif
                  //
                  //    Imagens contidas em arquivos
   if cType == 'C'     .and.;
      ('.'    $ xBitmap)
      if ('.ico' $ Lower(xBitmap))        // Imagem ICO
         if aSize      == NIL
            nNewWidth  := 32
            nNewHeight := 32
         else
            nNewWidth  := aSize[01]
            nNewHeight := aSize[02]
         endif

         oImage := XbpIcon():new():create()
         if !oImage:loadFile(xBitmap, nNewWidth, nNewHeight)
            oImage := NIL
         endif
                  //
                  //    Transformar ICO em BITMAP ?
         e_ico2Bitmap(lIco2Bitmap, @oImage, nBGIcon)
      else
         oImage  := XbpBitmap():new():create()
         if !oImage:loadFile(xBitmap)
            oImage:destroy()
            oImage := NIL
         else
            oImage:transparentClr := oImage:getDefaultBGColor()
         endif
      endif
      exit
   endif
                  //
                  //    Imagens ICO em arquivos RES ou DLLs
   if cUserDef <> NIL             .and.;
      ('ico'   $ Lower(cUserDef))
      oImage := XbpIcon():new():create()
      if     Empty(aSize)
                  //
                  //    Se no informado assume os mesmos tamanhos que XbpIcon()
                  //       para que o tamanho obtido da imagem possa ser reescalonado
             if !oImage:load(cDll, xBitmap, 32, 32)
                oImage := NIL
             endif
      elseif !oImage:load(cDll, xBitmap, aSize[01], aSize[02])
             oImage := NIL
      endif
                  //
                  //    Transformar ICO em BITMAP?
      e_ico2Bitmap(lIco2Bitmap, @oImage, nBGIcon)
      exit
   endif
                  //
                  //    xBitmap no est em arquivo nem  do formato ICO
   oImage := XbpBitmap():new()
   if oPS <> NIL
      oImage:create(oPS)
   else
      oImage:create()
   endif
                  //
                  //    xBitmap  um "resource" cuja USERDEF section no foi informada.
                  //            Pode estar em Dll
   if (cType    $ 'N') .and.;
      cUserDef == NIL
      if !oImage:load(cDll, xBitmap)
         oImage := NIL
      endif
      exit
   endif
                  //
                  //    Outros formatos de imagem contidos em arquivos RES ou Dlls
   cType := cUserDef
   if Empty(cType)
      nFormat        := XBPBMP_FORMAT_DEFAULT
   else
      cType          := Lower(cType)
      if     cType   == 'png'
             nFormat := XBPBMP_FORMAT_PNG
      elseif cType   == 'jpg'
             nFormat := XBPBMP_FORMAT_JPG
      elseif cType   == 'gif'
             nFormat := XBPBMP_FORMAT_GIF
      elseif cType   == 'bmp'
             nFormat := XBPBMP_FORMAT_DEFAULT
      else
             nFormat := XBPBMP_FORMAT_DEFAULT
      endif
   endif
   oImage:setBuffer(LoadResource(xBitmap, cDll, cUserDef), nFormat)
   if Empty(oImage:SetBuffer())
      oImage := NIL
   endif
   exit
enddo

do while oImage <> NIL                    .and.;
         !oImage:isDerivedFrom('XbpIcon')

   if aSize     == NIL
   if nRasterOp == NIL
   if nCompress == NIL
   if nState    == NIL
      exit
   endif
   endif
   endif
   endif
   if aSize      == NIL
      nNewWidth  := oImage:xSize
      nNewHeight := oImage:ySize
   else
      nNewWidth  := aSize[01]
      nNewHeight := aSize[02]
   endif
   if nRasterOp == NIL
      nRasterOp := GRA_BLT_ROP_MERGECOPY
   endif
   if nCompress == NIL
      nCompress := GRA_BLT_BBO_AND
   endif
   if nState == NIL
      nState := XBP_STATE_NORMAL
   endif

   oNewBmp := XbpBitmap():New():Create(oImage)
   oNewBmp:Make(nNewWidth, nNewHeight)
   oBmpPS := XbpPresSpace():New():Create(oImage)
   oNewBmp:PresSpace(oBmpPS)

   oBmpPS:setColor(oImage:getDefaultBGColor())
   GraBox(oBmpPS,      {0, 0}, {nNewWidth, nNewHeight}, GRA_FILL)
   oImage:Draw(oBmpPS, {0, 0,   nNewWidth, nNewHeight}, NIL, nRasterOp, nCompress, nState)
   oNewBmp:transparentClr := oImage:getDefaultBGColor()
   oImage                 := oNewBmp
   exit
enddo
RETURN oImage
 ////////////
 //
STATIC FUNCTION e_ico2Bitmap(lIco2Bitmap, oImage, nBGIcon)
 //    Transforma os objetos XbpIcon() em XbpBitmap().
 //               <@oImage> passado por referncia
 //    Retorna NIL
 /////
LOCAL  oBitmap, nBgColor, oPS4Image, aAttrA

do while lIco2Bitmap <> NIL .and.;
         lIco2Bitmap        .and.;
         oImage      <> NIL
   if nBgIcon == NIL
      nBgIcon := GRA_CLR_BACKGROUND
   endif

   if nBgIcon               == XBPSYSCLR_TRANSPARENT
      nBgColor              := oImage:getDefaultBgColor()
      oImage                := oImage:getBitmap()
      oImage:transparentClr :=  nBGColor
      exit
   endif

   oBitmap := XbpBitmap():new():create(oImage)
   oBitmap:Make(oImage:XSize, oImage:YSize)
   oPS4Image  := XbpPresSpace():New():Create(oImage)
   oBitmap:PresSpace(oPS4Image)

   aAttrA  := GraSetAttrArea(oPS4Image)
   aAttrA[GRA_AA_COLOR] := nBGIcon
   GraSetColor(oPS4Image, aAttrA[GRA_AA_COLOR])
   GraBox(oPS4Image, {0, 0}, {(oBitmap:xSize - 1),(oBitmap:ySize - 1)}, GRA_FILL)
   oImage:Draw(oPS4Image, {0, 0})
   oImage := oBitmap
   exit
enddo
RETURN NIL

 ////////////
 //
FUNCTION ApiLoadDll_(cDll)
 //      Retrrns the Dll handler or 0
 /////
STATIC aDllLoaded := {}                  // Dlls carregadas: {{cDllName, nDllHandle}, ...}
LOCAL  nDllHandle

cDll := Lower(AllTrim(cDll))
if Right(cDll, 4) <> '.dll'
   cDll           += '.dll'
endif

nDllHandle    := AScan(aDllLoaded, {|x| x[01] == cDll})
if nDllHandle  > 0
   nDllHandle := aDllLoaded[nDllHandle, 02]
else
   nDllHandle := DllLoad(cDll)
   AAdd(aDllLoaded, {cDll, nDllHandle})
endif
RETURN nDllHandle

FUNCTION ApiGetComputer_()
RETURN 'Computer Name'

FUNCTION Erro_()
RETURN 'An error occurred'

FUNCTION Arg2Char_(xData)
RETURN Var2Char(xData)

